package projcsc714.ncsu.edu;

import java.io.File;
import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;
import android.widget.Toast;

public class FileMonitoringService extends Service{
	private static final String TAG = "Profiler";
	private MyFileObserver fileOb;
	@Override
	public void onCreate() {
		if (!InformationStatic.is_sd_available()) {
			Toast.makeText(this, "SDCAR" +
					"D is not available!", Toast.LENGTH_SHORT).show();
			return;
		}
		File sdcard = new File("/sdcard/");
		createFileObs(sdcard);
	}
	
	private void createFileObs(File f) {
		if (f.isDirectory())
			fileOb = new MyFileObserver(f.getAbsolutePath());
	}
	
	@Override
	public void onStart(Intent intent, int startid) {
		fileOb.startWatching();
		Toast.makeText(this.getApplicationContext(), "start monitoring file modification", Toast.LENGTH_SHORT).show();
		Log.d(TAG, InformationStatic.accessLogMsg);	

	}
	@Override
	public void onDestroy() { 
		fileOb.stopWatching();
		Toast.makeText(this.getApplicationContext(), "stop monitoring file modification", Toast.LENGTH_SHORT).show();
		Log.d(TAG, InformationStatic.accessLogMsg);	
	}

	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}
}
