package projcsc714.ncsu.edu;
import projcsc714.ncsu.edu.InformationStatic;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.lang.reflect.InvocationTargetException;
import java.net.Socket;
import java.util.Calendar;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;
import java.util.TreeMap;
import android.net.*;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningAppProcessInfo;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.hardware.SensorManager;
import android.os.Environment;
import android.os.IBinder;
import android.os.Parcel;
import android.os.SystemClock;
import android.util.Log;
import android.util.SparseArray;
import android.widget.Toast;

public class monitoringService  extends Service {
	private static final String TAG = "Profiler";
	private Timer timer = new Timer();
	private static final long UPDATE_INTERVAL = 10000;
	/*
	 * Column 0: UID
	 * Column 1: PID
	 * Column 2: importance
	 * Column 3: hashcode
	 * Column 4: byte recv
	 * Column 5: byte sent
	 * Column 6: privatedirty (memory)
	 * Column 7: totalPSS(memory)
	 * Column 8: gettotalsharedDirty(memory)
	 * Column 9: CPUPower
	 * Column 10: SensorPower
	 * Column 11:
	 * 
	 */
	private long[][] INFO;
	private int MAXPID = 1024;
	private int MaxInfoColumn = 11;
	private long TimeStamp = 0;
	private int NUMPROC = -1;
	
	//gopi

    final String BATTERY_STATS_IMPL_CLASS = "com.android.internal.os.BatteryStatsImpl";
    final String POWER_PROFILE_CLASS = "com.android.internal.os.PowerProfile";
    final String M_BATTERY_INFO_CLASS = "com.android.internal.app.IBatteryStats";
    final String BATTERY_STATS_CLASS = "android.os.BatteryStats";
    final String UID_CLASS = BATTERY_STATS_CLASS + "$Uid";
    final String PROC_CLASS = UID_CLASS + "$Proc";
    final String SENSOR_CLASS = UID_CLASS + "$Sensor";
    final String BATTER_STATS_TIMER_CLASS = BATTERY_STATS_CLASS + "$Timer";
	  private Object mBatteryInfo_;
      private Object mStats;
      private Object mPowerProfile_;

      private int mStatsType_= InformationStatic.Battery_STATS_TOTAL;
      //final double averageCostPerByte = getDataCost();
      ActivityManager activityManager ;
      SensorManager sensorManager;

		private void initialize(){
			  try{
				  
		     	 mBatteryInfo_ = Class.forName("com.android.internal.app.IBatteryStats$Stub").getDeclaredMethod("asInterface",IBinder.class).invoke(null, Class.forName("android.os.ServiceManager")
		                               .getMethod("getService", String.class).invoke(null, "batteryinfo"));
		        byte[] data = (byte[])Class.forName(M_BATTERY_INFO_CLASS).getDeclaredMethod("getStatistics",null).invoke(mBatteryInfo_, null);
		        Parcel parcel = Parcel.obtain();
		         parcel.unmarshall(data, 0, data.length);
		         parcel.setDataPosition(0);
		         mStats = Class.forName(BATTERY_STATS_IMPL_CLASS).getField("CREATOR").getType().getMethod("createFromParcel", Parcel.class)
		         				.invoke(Class.forName(BATTERY_STATS_IMPL_CLASS).getField("CREATOR").get(null), parcel);
		         mPowerProfile_ = Class.forName(POWER_PROFILE_CLASS).getConstructor(Context.class).newInstance(this);
		         
			  }catch(InvocationTargetException e){
		         Log.e("BatteryTester", "Exception: " + e);
		         e.printStackTrace();
			  } catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				  System.out.println("illegal");
				  e.printStackTrace();
			  } catch (SecurityException e) {
				System.out.println("security");
				// TODO Auto-generated catch block
				e.printStackTrace();
			  } catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				System.out.println("access");
				e.printStackTrace();
			  } catch (NoSuchMethodException e) {
				// TODO Auto-generated catch block
				  System.out.println("no method");
				  e.printStackTrace();
			  } catch (NoSuchFieldException e) {
				// TODO Auto-generated catch block
				  System.out.println("no feld");
				  e.printStackTrace();
			  } catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				  System.out.println("no class");
				  e.printStackTrace();
			  }
			  catch (NullPointerException e) {
				// TODO Auto-generated catch block
				System.out.println("null");	
				e.printStackTrace();
			  } catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 

		      activityManager = (ActivityManager) this.getSystemService(ACTIVITY_SERVICE);
		      sensorManager = (SensorManager)this.getSystemService(SENSOR_SERVICE);

		}
	private void gatherCPUSensorInfo() {
	        
	        initialize();
	        
	        try {
				SparseArray uidStats = (SparseArray)Class.forName(BATTERY_STATS_IMPL_CLASS).getMethod("getUidStats", null).invoke(mStats, null);
				
				for(int i = 0;i<uidStats.size();i++){
					Object uid = uidStats.valueAt(i);
					
					
					final int which = mStatsType_;
					long uSecTime = (Long)Class.forName(BATTERY_STATS_IMPL_CLASS).getMethod("computeBatteryRealtime", java.lang.Long.TYPE, java.lang.Integer.TYPE)
	                .invoke(mStats, SystemClock.elapsedRealtime() * 1000, which);
					
					int proc_uid = (Integer)Class.forName(UID_CLASS).getMethod("getUid", (Class[])null).invoke(uid, null);
	        		   Log.d(TAG, "proc_uid"+proc_uid);


					//CPU usage 
					 Map<String, Object> processStats = (Map)Class.forName(UID_CLASS).getMethod("getProcessStats", (Class[])null).invoke(uid, null);
				     long cpuPower=0;
				     long foreTime =0;
				     if(processStats.size()>0){
				    	 for(Map.Entry<String, Object>entry:processStats.entrySet()){
				    		 Object process = entry.getValue();
				    		 
				    		 final long userTime = (Long)Class.forName(PROC_CLASS).getMethod("getUserTime", java.lang.Integer.TYPE).invoke(process, which);
	                         final long systemTime = (Long)Class.forName(PROC_CLASS).getMethod("getSystemTime", java.lang.Integer.TYPE).invoke(process, which);
	                         final long foregroundTime = (Long)Class.forName(PROC_CLASS).getMethod("getForegroundTime", java.lang.Integer.TYPE).invoke(process, which);
	                         foreTime += foregroundTime *10; 
	                         final long tmpCpuTime = (userTime + systemTime) * 10; 
	                         final double processPower = tmpCpuTime * 0.2;
	                         cpuPower+=processPower;                        
	                      
				    	 }
		        		   Log.d(TAG, "cpuPower"+cpuPower);

				    	 int j;
			        	   for( j =0;j<INFO.length;j++){
			        		   if(proc_uid == INFO[j][0])
			        			   break;
			        	   }
			        	   if(j<INFO.length){
			        		   INFO[j][9] = cpuPower;
			        		   Log.d(TAG, "INFO["+ j +"]--CPU"+INFO[j][9]);

			        	   }
				     }
				
				     //Sensor usage //
					Map<Integer, Object> sensorStatistics = (Map)Class.forName(UID_CLASS).getMethod("getSensorStats", (Class[])null).invoke(uid);
					float sensorPower = 0;
					long gpsTime = 0;
					for(Map.Entry<Integer, Object> sensorEntry: sensorStatistics.entrySet()){
						 Object sensor = sensorEntry.getValue();
	                     int sensorType = (Integer)Class.forName(SENSOR_CLASS).getMethod("getHandle", (Class[])null).invoke(sensor);
	                     Object timer = Class.forName(SENSOR_CLASS).getMethod("getSensorTime", (Class[])null).invoke(sensor);
	                     long sensorTime = (Long)Class.forName(BATTER_STATS_TIMER_CLASS)
	                     .getMethod("getTotalTimeLocked", java.lang.Long.TYPE, java.lang.Integer.TYPE)
	                     .invoke(timer, uSecTime, which);
	                     double tempPower = 0;
	                     
	                     switch(sensorType){

	                     //GPS
	                     case -10000:
	                             tempPower = (Double)Class.forName(POWER_PROFILE_CLASS).getMethod("getAveragePower", String.class)
	                             .invoke(mPowerProfile_, PowerProfileConstants.POWER_GPS_ON);
	                             gpsTime = sensorTime;
	                             break;
	                     default:
	                             android.hardware.Sensor sensorData = sensorManager.getDefaultSensor(1);
	                             if(sensorData != null) {
	                                     tempPower = sensorData.getPower();
	                             }
	                             
	                     }
	                     sensorPower += (tempPower * sensorTime) /1000;
	         
					}
					int j;
					  for( j =0;j<INFO.length;j++){
		        		   if(proc_uid == INFO[j][0])
		        			   break;
		        	   }
		        	   if(j<INFO.length){
		        		   INFO[j][10] = (long)sensorPower;
		        		   Log.d(TAG, "INFO["+ j +"]--SensorPower"+INFO[j][10]);

		        	   }  
				}
	        } catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (SecurityException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchMethodException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	        
	    }

	private double getDataCost(){
		return 0.1;
	}

	private void getMemoryinfo(){
		
		 
		 List<RunningAppProcessInfo> runningAppProcesses = activityManager.getRunningAppProcesses();

	       Map<Integer, String> pidMap = new TreeMap<Integer, String>();
	       Map<Integer, String> uidMap = new TreeMap<Integer, String>();
	       for (RunningAppProcessInfo runningAppProcessInfo : runningAppProcesses)
	       {
	       	uidMap.put(runningAppProcessInfo.uid, runningAppProcessInfo.processName);
	           pidMap.put(runningAppProcessInfo.pid, runningAppProcessInfo.processName);
	       }

	       Collection<Integer> keys = pidMap.keySet();

	       for(int key : keys)
	       {
	      
	           int pids[] = new int[1];
	           pids[0] = key;
	           android.os.Debug.MemoryInfo[] memoryInfoArray = activityManager.getProcessMemoryInfo(pids);
	           for(android.os.Debug.MemoryInfo pidMemoryInfo: memoryInfoArray)
	           {
	        	   int i;
	        	   for( i =0;i<INFO.length;i++){
	        		   if(pids[0] == INFO[i][1])
	        			   break;
	        	   }
	        	   if(i<INFO.length){
	        		   INFO[i][6] =  pidMemoryInfo.getTotalPrivateDirty();
	        		   INFO[i][7]= pidMemoryInfo.getTotalPss();
	        		   INFO[i][8]=pidMemoryInfo.getTotalSharedDirty();
	        		   Log.d(TAG, "INFO["+ i +"]--dirty"+INFO[i][6]);
	        		   Log.d(TAG, "INFO["+ i +"]--PSS"+INFO[i][7]);
	        		   Log.d(TAG, "INFO["+ i +"]--shareddirty"+INFO[i][8]);
	        		   
	        	   }
	        	   
	           }
	       }
	     
	}
	//gopi
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	@Override
	public void onCreate() {
		Toast.makeText(this, "Profiler Service Created", Toast.LENGTH_LONG).show();
		Log.d(TAG, "onCreate");
		INFO = new long[MAXPID][MaxInfoColumn];
		initialize();
	}
	@Override
	public void onDestroy() {
		Toast.makeText(this, "Profiler Service Stopped", Toast.LENGTH_LONG).show();
		Log.d(TAG, "onDestroy");
		timer.cancel();	
	}
	@Override
	public void onStart(Intent intent, int startid) {
		Toast.makeText(this, "Profiler Service Started", Toast.LENGTH_LONG).show();
		Log.d(TAG, "onStart");
		  _startService();
	}
	private void _startService() {
		
		  timer.scheduleAtFixedRate(
		      new TimerTask() {
		        public void run() {
		          SERVICE();
		          }
		        },
		        0,UPDATE_INTERVAL);	  
		  Log.i(getClass().getSimpleName(), "Timer started!!!");
	}
	private void SERVICE(){
		Log.d(TAG, "SERVICE is RUNNING");
		// getting the time
		Calendar cal = Calendar.getInstance();
		TimeStamp = cal.getTimeInMillis();
    	
		 
    	// populate the array
		
    	// first procs info -- INFO[XX][0] is the UID of APPs
		Procs();
				
		// network info 
		NetworkMonitor();
			
		//memory info
		getMemoryinfo();
		//CPU & Battery & sensor info
		gatherCPUSensorInfo();
		
		// write to file
		if (InformationStatic.FILE == true)
			print();
		
		if (InformationStatic.SOCKET == true)
			printSocket();
		
		//lets print the file manipulation changes too!
		printFileManipulation();
		
	}

	private void Procs()
	{
            ActivityManager actvityManager = (ActivityManager)this.getSystemService( ACTIVITY_SERVICE );
    		List<RunningAppProcessInfo> procInfos = actvityManager.getRunningAppProcesses();
    		
    		NUMPROC = procInfos.size();
    		
    		for(int i = 0; i < NUMPROC; i++){
    			Log.d(TAG, "uid["+ i +"]"+procInfos.get(i).uid);
    			INFO[i][0] = procInfos.get(i).uid;
    			INFO[i][1] = procInfos.get(i).pid;
    			INFO[i][2] = procInfos.get(i).importance;
    			INFO[i][3] = procInfos.get(i).hashCode();
    		}
	}
	private void NetworkMonitor()
	{
		int uid;
		for(int i = 0; i < NUMPROC; i++){
    		uid = (int) INFO[i][0];
    		//bytes_recv 
			
    		INFO[i][4] = TrafficStats.getUidRxBytes(uid);
    		//no_recv
	      	INFO[i][5] = TrafficStats.getUidTxBytes(uid);
	      	
	      	Log.d(TAG, "pid["+ uid +"],byte recv:"+INFO[i][4]);
	      	
	      	Log.d(TAG, "pid["+ uid +"],byte sent:"+INFO[i][5]);
	      	
	      	// needs "API-12"
	      	//payload_bytes_recv_tcp
	      	//INFO[i][12] = TrafficStats.getUidTcpRxBytes(uid);
	        //
	      	//payload_bytes_sent_tcp 
	      	//INFO[i][13] = TrafficStats.getUidTcpTxBytes(uid);
	      	//
	        //long no_seg_sent_tcp 
	      	//INFO[i][14] = TrafficStats.getUidTcpTxSegments(uid);
	      	//
	      	//long payload_bytes_sent_udp 
	      	//INFO[i][15] = TrafficStats.getUidUdpTxBytes(uid);
	      	//
	      	//long packet_sent_udp 
	      	//INFO[i][16] = TrafficStats.getUidUdpTxPackets(uid); 	
		}
	}
			
	private void printFileManipulation()
	{
		try {
		    File root = Environment.getExternalStorageDirectory();
		    if (root.canWrite()){
		        File gpxfile = new File(root, "log_files.out");
		        FileWriter gpxwriter = new FileWriter(gpxfile,true);
		        BufferedWriter out = new BufferedWriter(gpxwriter);
		        out.write(	InformationStatic.accessLogMsg);
		        InformationStatic.accessLogMsg ="";
		        out.close();
    			Log.d(TAG, "writing to file"+"log_files.out");
		    }
		    else 
    			Log.d(TAG, "cannot write to SD"+"log_files.out");
		} catch (IOException e) {
		    Log.e(TAG, "Could not write file " + e.getMessage());
		}
	}
	
	private void print()
	{
		int  i = 0;
		try {
		    File root = Environment.getExternalStorageDirectory();
		    if (root.canWrite()){
		        File _file = new File(root, " log.out ");
		        FileWriter _fwriter = new FileWriter(_file,true);
		        BufferedWriter out = new BufferedWriter(_fwriter);
		        out.write("["+TimeStamp+"]:\r\n");
		        for (i = 0; i< NUMPROC; i++){
		        		out.write("APP"+ i);
		        		out.write(" UID:"+INFO[i][0]);
		        		out.write(" PID:"+INFO[i][1]);
		        		out.write(" importance:"+INFO[i][2]);
		        		out.write(" hashcode:"+INFO[i][3]);
		        		out.write(" byte_recv:"+INFO[i][4]);
		        		out.write(" byte_sent:"+INFO[i][5]);
		        		out.write(" TotalprivateDirty(memory):"+INFO[i][6]);
		        		out.write(" TotalPSS(memory):"+INFO[i][5]);
		        		out.write(" TotalSharedDirty(memory):"+INFO[i][7]);
		        		out.write(" CPUPower:"+INFO[i][8]);
		        		out.write(" SensorPower:"+INFO[i][9]);
		        		out.write("\r\n");
		        }
		        out.close();
    			Log.d(TAG, "writing to file "+ " log.out ");
		    }
		    else 
    			Log.d(TAG, "cannot write to SD "+ " log.out ");
		} catch (IOException e) {
		    Log.e(TAG, "Could not write file " + e.getMessage());
		}
	}
	
	private void printSocket()
	{
		Socket requestSocket;
		ObjectOutputStream out;
		int i;
		try{
			requestSocket = new Socket(InformationStatic.ServerName, InformationStatic.ServerPort);
			Log.e(TAG, "Connected to"+InformationStatic.ServerName);
			
			out = new ObjectOutputStream(requestSocket.getOutputStream());
			out.flush();
		
			out.writeObject("["+TimeStamp+"]:\r\n");
			out.flush();
			for (i = 0; i< NUMPROC; i++){
				out.writeObject("APP"+ i);
				out.writeObject(" UID:"+INFO[i][0]);
				out.writeObject(" PID:"+INFO[i][1]);
				out.writeObject(" importance:"+INFO[i][2]);
				out.writeObject(" hashcode:"+INFO[i][3]);
				out.writeObject(" byte_recv:"+INFO[i][4]);
				out.writeObject(" byte_sent:"+INFO[i][5]);
				out.writeObject(" TotalprivateDirty(memory):"+INFO[i][6]);
				out.writeObject(" TotalPSS(memory):"+INFO[i][5]);
				out.writeObject(" TotalSharedDirty(memory):"+INFO[i][7]);
				out.writeObject(" CPUPower:"+INFO[i][8]);
				out.writeObject(" SensorPower:"+INFO[i][9]);
				out.writeObject("\r\n");
				out.flush();
			}
			out.close();
		}
		catch(IOException ioException){
			ioException.printStackTrace();
		}
	}

}